// Generated by LiveScript 1.2.0
/** ^
 * Copyright (c) 2013-2014 Quildreen Motta
 *
 * Permission is hereby granted, free of charge, to any person
 * obtaining a copy of this software and associated documentation files
 * (the "Software"), to deal in the Software without restriction,
 * including without limitation the rights to use, copy, modify, merge,
 * publish, distribute, sublicense, and/or sell copies of the Software,
 * and to permit persons to whom the Software is furnished to do so,
 * subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
 * LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
 * OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
 * WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */
(function(){
  var Future, flaw, TimeoutError, delay, timeout, parallel, nondeterministicChoice, out$ = typeof exports != 'undefined' && exports || this;
  Future = require('data.future');
  flaw = require('flaw');
  TimeoutError = function(n){
    return flaw('TimeoutError', "Timeoutted after " + n + " milliseconds.");
  };
  out$.delay = delay = function(n){
    return new Future(function(reject, resolve){
      var s;
      s = new Date;
      setTimeout(function(){
        return resolve(new Date - s);
      }, n);
    });
  };
  out$.timeout = timeout = function(n){
    return new Future(function(reject, resolve){
      var s;
      s = new Date;
      setTimeout(function(){
        return reject(TimeoutError(n));
      }, n);
    });
  };
  out$.parallel = parallel = function(xs){
    return new Future(function(reject, resolve){
      var len, result, resolved, i$, ref$, len$, i, x;
      len = xs.length;
      result = new Array(len);
      resolved = false;
      for (i$ = 0, len$ = (ref$ = xs).length; i$ < len$; ++i$) {
        i = i$;
        x = ref$[i$];
        compute(x, i);
      }
      function compute(x, i){
        return x.fork(function(e){
          if (resolved) {
            return;
          }
          resolved = true;
          return reject(e);
        }, function(v){
          if (resolved) {
            return;
          }
          result[i] = v;
          len = len - 1;
          if (len === 0) {
            resolved = true;
            return resolve(result);
          }
        });
      }
    });
  };
  out$.nondeterministicChoice = nondeterministicChoice = function(xs){
    return new Future(function(reject, resolve){
      var resolved, i$, ref$, len$, i, x;
      resolved = false;
      for (i$ = 0, len$ = (ref$ = xs).length; i$ < len$; ++i$) {
        i = i$;
        x = ref$[i$];
        x.fork(fn$, fn1$);
      }
      function transition(f, a){
        if (!resolved) {
          resolved = true;
          return f(a);
        }
      }
      function fn$(e){
        return transition(reject, e);
      }
      function fn1$(v){
        return transition(resolve, v);
      }
    });
  };
}).call(this);
